﻿selObj = activeDocument.selection;
selObjCount = selObj.length; //選択されたパスの数

anchor = new Array(); //アンカーポイント座標
segment = new Array(); //セグメント座標
kouten = new Array(); //交点座標
pathPointsLen =  new Array(); //各パスのポイント数
fourPoint =  new Array(); //4点の座標

poObj = new Array(); //ポイントが含まれるパスの番号
poObjPoNum = new Array(); //各ポイントのパス上の位置

selPointCount =0; //選択されているポイントの数
selSegmCount = 0; //選択されているセグメントの数



//選択内容の確認と、必要な座標取得

for(i=0; i<selObjCount; i++){
    if(selObj[i].typename　==　"PathItem"){
        pathPointsLen[i] = selObj[i].pathPoints.length;


        if(selObj[i].selectedPathPoints.length == 2){ //選択ポイント数2の場合
            
            if(selObj[i].pathPoints[0].selected == PathPointSelection.ANCHORPOINT){//始点を選択の場合
                
                selPointCount++;
                poObj[selPointCount] = i;
                poObjPoNum[selPointCount] = 0;

                anchor[selPointCount*2-2] = selObj[i].pathPoints[0].anchor;
                anchor[selPointCount*2-1] = selObj[i].pathPoints[1].anchor;
            }

            else if(selObj[i].pathPoints[pathPointsLen[i] -1].selected == PathPointSelection.ANCHORPOINT){//終点を選択の場合
            
                selPointCount++;
                poObj[selPointCount] = i;
                poObjPoNum[selPointCount] = pathPointsLen[i] -1;

                anchor[selPointCount*2-2] = selObj[i].pathPoints[pathPointsLen[i] -1].anchor;
                anchor[selPointCount*2-1] = selObj[i].pathPoints[pathPointsLen[i] -2].anchor;
            }
        
            else if( selObj[i].pathPoints[pathPointsLen[i] -1].selected == PathPointSelection.RIGHTDIRECTION && selObj[i].pathPoints[0].selected == PathPointSelection.LEFTDIRECTION ){
                        
                selSegmCount++;
                segment[0] = selObj[i].pathPoints[pathPointsLen[i] -1].anchor;
                segment[1] = selObj[i].pathPoints[0].anchor;
            }

            else {
                for(j=0; j<pathPointsLen[i] -1; j++){//セグメントを選択の場合
                    
                    if( selObj[i].pathPoints[j].selected == PathPointSelection.RIGHTDIRECTION && selObj[i].pathPoints[j+1].selected == PathPointSelection.LEFTDIRECTION ){
                        
                        selSegmCount++;
                        segment[0] = selObj[i].pathPoints[j].anchor;
                        segment[1] = selObj[i].pathPoints[j+1].anchor;
                    }
                }
            }
        }


       else if(selObj[i].selectedPathPoints.length > 2){ //選択ポイント数3以上の場合
            
            for(j=0; j<pathPointsLen[i] -1; j++){//選択セグメントを取得
                    
                if( selObj[i].pathPoints[j].selected == PathPointSelection.RIGHTDIRECTION && selObj[i].pathPoints[j+1].selected == PathPointSelection.LEFTDIRECTION ){
                        
                    selSegmCount++;
                    segment[0] = selObj[i].pathPoints[j].anchor;
                    segment[1] = selObj[i].pathPoints[j+1].anchor;
                }
            }

            if(selObj[i].pathPoints[0].selected == PathPointSelection.ANCHORPOINT){//始点を選択の場合
                
                selPointCount++;
                poObj[selPointCount] = i;
                poObjPoNum[selPointCount] = 0;

                anchor[selPointCount*2-2] = selObj[i].pathPoints[0].anchor;
                anchor[selPointCount*2-1] = selObj[i].pathPoints[1].anchor;
            }

            if(selObj[i].pathPoints[pathPointsLen[i] -1].selected == PathPointSelection.ANCHORPOINT){//終点を選択の場合
            
                selPointCount++;
                poObj[selPointCount] = i;
                poObjPoNum[selPointCount] = pathPointsLen[i] -1;

                anchor[selPointCount*2-2] = selObj[i].pathPoints[pathPointsLen[i] -1].anchor;
                anchor[selPointCount*2-1] = selObj[i].pathPoints[pathPointsLen[i] -2].anchor;
            }
        }
    }
}


//選択ミスのチェックとエラー表示
if (selSegmCount　>1) alert("選択できるセグメントは1本だけです。");
    else if (selPointCount == 0) alert("ポイントを選択してください。");
    else if (selSegmCount　== 1 && selPointCount == 0) alert("セグメントに揃えたいポイントを選択してください。");
    else if (selSegmCount == 0 && selPointCount== 1) alert("2点のアンカーポイント、またはアンカーポイントと1本のセグメントを選択してください。");
    else if (selSegmCount == 0 && selPointCount>2)  alert("交点が特定できません");
    else{
    

    //メイン処理
    
    if(selSegmCount　== 0){ //アンカーポイント2点選択の場合の処理
        fourPoint[0] =anchor[0];
        fourPoint[1] =anchor[1];
        fourPoint[2] =anchor[2];
        fourPoint[3] =anchor[3];

        koutenCalculation();
    
        moveToKouten(1);
        moveToKouten(2);
    }
    
    else{//セグメントにアンカーポイントを揃える処理
        fourPoint[0] = segment[0];
        fourPoint[1] = segment[1];
        
        for(i=0; i<selPointCount; i++){
            
            fourPoint[2] =　anchor[i*2];
            fourPoint[3] =　anchor[i*2+1];
            
            koutenCalculation();
    
            moveToKouten(i+1);
        }
    }
}



function koutenCalculation(){//交点計算
    
    katamuki1Flag = "naname1";
    katamuki2Flag = "naname2";
        
        
    //パスの傾きと切片1取得
    if (fourPoint[0][1] == fourPoint[1][1]) { 
            
        katamuki1 = 0;
        katamuki1Flag = "suihei";
        seppen1 = fourPoint[0][1];
        kouten[1]  = fourPoint[0][1];
            
    } else if (fourPoint[0][0] == fourPoint[1][0]) { 
            
        katamuki1 = 0;        
        katamuki1Flag = "suityoku";
        seppen1 = fourPoint[0][0];
        kouten[0]  = fourPoint[0][0];

    } else {

        seppen1 = (fourPoint[0][0] * fourPoint[1][1] - fourPoint[1][0] * fourPoint[0][1])/(fourPoint[0][0] - fourPoint[1][0]);

        if(fourPoint[1][0] != 0) 
            katamuki1 = (fourPoint[1][1]-seppen1)/fourPoint[1][0];
        else katamuki1 = (fourPoint[0][1]-seppen1)/fourPoint[0][0];
    }


    //パスの傾きと切片2取得
    if (fourPoint[2][1] == fourPoint[3][1]) { 

        katamuki2 = 0;
        katamuki2Flag = "suihei";
        seppen2 = fourPoint[2][1];
        kouten[1]  = fourPoint[2][1];
  
    } else if (fourPoint[2][0] == fourPoint[3][0]) { 
            
        katamuki2 = 0;
        katamuki2Flag = "suityoku";
        seppen2 = fourPoint[2][0];
        kouten[0]  = fourPoint[2][0];
            
    } else {
            
        seppen2 = (fourPoint[2][0] * fourPoint[3][1] - fourPoint[3][0] * fourPoint[2][1])/(fourPoint[2][0] - fourPoint[3][0]);

        if(fourPoint[3][0] != 0) 
            katamuki2 = (fourPoint[3][1]-seppen2)/fourPoint[3][0];
        else katamuki2 = (fourPoint[2][1]-seppen2)/fourPoint[2][0];
    }


    //傾きに応じた交点の取得
    if(katamuki1Flag == katamuki2Flag ) alert("選択されているパスが平行線なので交わりません。");
    else if(katamuki1Flag == "naname1" && katamuki1 == katamuki2) alert("選択されているパスが平行線なので交わりません。");
    else{
            
        if(katamuki1 != katamuki2 && katamuki1Flag == "naname1" && katamuki2Flag == "naname2"){

            kouten[0] = (seppen2-seppen1)/(katamuki1-katamuki2);
            kouten[1] = (katamuki1*seppen2-seppen1*katamuki2)/(katamuki1-katamuki2);
        }
        
        else if(katamuki1Flag  == "suihei" && katamuki2Flag == "naname2"){ //1本目が水平

            kouten[0]  = ( kouten[1]-seppen2)/katamuki2;
        }
        
        else if(katamuki1Flag  == "suityoku" && katamuki2Flag == "naname2"){ //1本目が垂直
                
            kouten[1] = katamuki2*kouten[0] +seppen2;
        }

        else if(katamuki1Flag  == "naname1" && katamuki2Flag == "suihei"){ //2本目が水平

            kouten[0]  = ( kouten[1]-seppen1)/katamuki1;
        }
        else if(katamuki1Flag  == "naname1" && katamuki2Flag == "suityoku"){ //2本目が垂直
                
            kouten[1] = katamuki1*kouten[0] +seppen1;
     
        }
    }
}



function moveToKouten(pointNum){//各ポイントをそれぞれ求められた交点へ移動

    docArea = activeDocument.views[0].bounds; //ウィンドウの表示範囲取得
                
    if(kouten[0] > docArea[0] && kouten[1] < docArea[1] && docArea[2]> kouten[0] && kouten[1]>docArea[3]) {//交点が表示範囲に収まるか確認

        selObj[poObj[pointNum]].pathPoints[poObjPoNum[pointNum]].anchor = kouten;
        selObj[poObj[pointNum]].pathPoints[poObjPoNum[pointNum]].leftDirection = kouten;
        selObj[poObj[pointNum]].pathPoints[poObjPoNum[pointNum]].rightDirection = kouten;
    }
}
